? patch.diff
Index: include/winsock.h
===================================================================
RCS file: /home/wine/wine/include/winsock.h,v
retrieving revision 1.45
diff -u -r1.45 winsock.h
--- include/winsock.h	31 May 2002 23:06:49 -0000	1.45
+++ include/winsock.h	22 Sep 2002 20:20:39 -0000
@@ -399,7 +399,6 @@
 #endif /* !USE_WS_PREFIX && !__WINE_USE_MSVCRT */
 
 #ifdef WS_DEFINE_SELECT
-# undef WS_DEFINE_SELECT
 /* Define our own version of select and the associated types and macros */
 
 # ifndef USE_WS_PREFIX
@@ -456,7 +455,7 @@
     u_int __i; \
     for (__i = 0; __i < ((cast*)(set))->fd_count ; __i++) \
     { \
-        if ((cast*)(set))->fd_array[__i]=(fd) \
+        if (((cast*)(set))->fd_array[__i]==(fd)) \
             break; \
     } \
     if (__i == ((cast*)(set))->fd_count && ((cast*)(set))->fd_count < FD_SETSIZE) \
@@ -467,21 +466,21 @@
 } while(0)
 
 #ifndef __WINE_WINSOCK2__
-#define __WS_FD_SET(fd, set, cast) __WS_FD_SET1((fd),(set), (cast))
+#define __WS_FD_SET(fd, set, cast) __WS_FD_SET1((fd),(set), cast)
 #else
-#define __WS_FD_SET(fd, set, cast) __WS_FD_SET2((fd),(set), (cast))
+#define __WS_FD_SET(fd, set, cast) __WS_FD_SET2((fd),(set), cast)
 #endif
 
 #ifndef USE_WS_PREFIX
-#define FD_CLR(fd, set)      __WS_FD_CLR((fd),(set), WS(fd_set))
-#define FD_SET(fd, set)      __WS_FD_SET((fd),(set), WS(fd_set))
-#define FD_ZERO(set)         (((WS(fd_set)*)(set))->fd_count=0)
-#define FD_ISSET(fd, set)    __WSAFDIsSet((SOCKET)(fd), (WS(fd_set)*)(set))
+#define FD_CLR(fd, set)      __WS_FD_CLR((fd),(set), fd_set)
+#define FD_SET(fd, set)      __WS_FD_SET((fd),(set), fd_set)
+#define FD_ZERO(set)         (((fd_set*)(set))->fd_count=0)
+#define FD_ISSET(fd, set)    __WSAFDIsSet((SOCKET)(fd), (fd_set*)(set))
 #else
-#define WS_FD_CLR(fd, set)   WINE_FD_CLR((fd),(set), WS(fd_set))
-#define WS_FD_SET(fd, set)   WINE_FD_SET((fd),(set), WS(fd_set))
-#define WS_FD_ZERO(set)      (((WS(fd_set)*)(set))->fd_count=0)
-#define WS_FD_ISSET(fd, set) __WSAFDIsSet((SOCKET)(fd), (WS(fd_set)*)(set))
+#define WS_FD_CLR(fd, set)   WINE_FD_CLR((fd),(set), WS_fd_set)
+#define WS_FD_SET(fd, set)   WINE_FD_SET((fd),(set), WS_fd_set)
+#define WS_FD_ZERO(set)      ((WS_fd_set*)(set))->fd_count=0)
+#define WS_FD_ISSET(fd, set) __WSAFDIsSet((SOCKET)(fd), (WS_fd_set*)(set))
 #endif
 #endif /* WS_DEFINE_SELECT */
 
@@ -911,7 +910,7 @@
 struct WS(protoent)* WINAPI WS(getprotobyname)(const char*);
 struct WS(protoent)* WINAPI WS(getprotobynumber)(int);
 #ifdef WS_DEFINE_SELECT
-int WS(select)(int,WS(fd_set)*,WS(fd_set)*,WS(fd_set)*,const struct WS(timeval)*);
+int WINAPI WS(select)(int,WS(fd_set)*,WS(fd_set)*,WS(fd_set)*,const struct WS(timeval)*);
 #endif
 struct WS(servent)* WINAPI WS(getservbyname)(const char*,const char*);
 struct WS(servent)* WINAPI WS(getservbyport)(int,const char*);
Index: include/msvcrt/crtdbg.h
===================================================================
RCS file: /home/wine/wine/include/msvcrt/crtdbg.h,v
retrieving revision 1.3
diff -u -r1.3 crtdbg.h
--- include/msvcrt/crtdbg.h	10 Mar 2002 00:02:38 -0000	1.3
+++ include/msvcrt/crtdbg.h	22 Sep 2002 20:20:39 -0000
@@ -51,9 +51,9 @@
 
 #ifndef _DEBUG
 
-#define _ASSERT(expr)                   (0)
-#define _ASSERTE(expr)                  (0)
-#define _CrtDbgBreak()                  (0)
+#define _ASSERT(expr)                   ((void)0)
+#define _ASSERTE(expr)                  ((void)0)
+#define _CrtDbgBreak()                  ((void)0)
 
 #else /* _DEBUG */
 
@@ -63,27 +63,27 @@
 #if defined(__GNUC__) && defined(__i386__)
 #define _CrtDbgBreak()                  __asm__ ("\tint $0x3\n")
 #else
-#define _CrtDbgBreak()                  (0)
+#define _CrtDbgBreak()                  ((void)0)
 #endif
 
 #endif /* _DEBUG */
 
-#define _CrtCheckMemory()               (1)
-#define _CrtDbgReport(...)              (0)
-#define _CrtDoForAllClientObjects(f,c)  (0)
-#define _CrtDumpMemoryLeaks()           (0)
-#define _CrtIsMemoryBlock(p,s,r,f,l)    (1)
-#define _CrtIsValidHeapPointer(p)       (1)
-#define _CrtIsValidPointer(p,s,a)       (1)
-#define _CrtMemCheckpoint(s)            (0)
-#define _CrtMemDifference(s1,s2,s3)     (0)
-#define _CrtMemDumpAllObjectsSince(s)   (0)
-#define _CrtMemDumpStatistics(s)        (0)
-#define _CrtSetAllocHook(f)             (0)
-#define _CrtSetBreakAlloc(a)            (0)
-#define _CrtSetDbgFlag(f)               (0)
-#define _CrtSetDumpClient(f)            (0)
-#define _CrtSetReportMode(t,m)          (0)
+#define _CrtCheckMemory()               ((int)1)
+#define _CrtDbgReport(...)              ((int)0)
+#define _CrtDoForAllClientObjects(f,c)  ((void)0)
+#define _CrtDumpMemoryLeaks()           ((int)0)
+#define _CrtIsMemoryBlock(p,s,r,f,l)    ((int)1)
+#define _CrtIsValidHeapPointer(p)       ((int)1)
+#define _CrtIsValidPointer(p,s,a)       ((int)1)
+#define _CrtMemCheckpoint(s)            ((void)0)
+#define _CrtMemDifference(s1,s2,s3)     ((int)0)
+#define _CrtMemDumpAllObjectsSince(s)   ((void)0)
+#define _CrtMemDumpStatistics(s)        ((void)0)
+#define _CrtSetAllocHook(f)             ((void)0)
+#define _CrtSetBreakAlloc(a)            ((long)0)
+#define _CrtSetDbgFlag(f)               ((int)0)
+#define _CrtSetDumpClient(f)            ((void)0)
+#define _CrtSetReportMode(t,m)          ((int)0)
 
 #define _RPT0(t,m)
 #define _RPT1(t,m,p1)