From 3536599287afdc8ebc081aba5481cff486c62715 Mon Sep 17 00:00:00 2001
From: Yusuf Khan <yusisamerican@gmail.com>
Date: Fri, 22 Oct 2021 15:29:06 -0700
Subject: [PATCH] xinput: Add xinputuap.dll

On certain application regarding controllers, including this
dll will allow the applications to boot.

Note: in the version.rc file I do not know if I should
credit myself.

Signed-off-by: Yusuf Khan <yusisamerican@gmail.com>
---
 configure.ac                  |  1 +
 dlls/xinputuap/Makefile.in    |  8 ++++++++
 dlls/xinputuap/version.rc     | 27 +++++++++++++++++++++++++++
 dlls/xinputuap/xinputuap.spec |  1 +
 4 files changed, 37 insertions(+)
 create mode 100644 dlls/xinputuap/Makefile.in
 create mode 100644 dlls/xinputuap/version.rc
 create mode 100644 dlls/xinputuap/xinputuap.spec

diff --git a/configure.ac b/configure.ac
index 5b2f8341cfb..e9ebfaed682 100644
--- a/configure.ac
+++ b/configure.ac
@@ -3604,6 +3604,7 @@ WINE_CONFIG_MAKEFILE(dlls/xinput1_3)
 WINE_CONFIG_MAKEFILE(dlls/xinput1_3/tests)
 WINE_CONFIG_MAKEFILE(dlls/xinput1_4)
 WINE_CONFIG_MAKEFILE(dlls/xinput9_1_0)
+WINE_CONFIG_MAKEFILE(dlls/xinputuap)
 WINE_CONFIG_MAKEFILE(dlls/xmllite)
 WINE_CONFIG_MAKEFILE(dlls/xmllite/tests)
 WINE_CONFIG_MAKEFILE(dlls/xolehlp)
diff --git a/dlls/xinputuap/Makefile.in b/dlls/xinputuap/Makefile.in
new file mode 100644
index 00000000000..5d311fe7c31
--- /dev/null
+++ b/dlls/xinputuap/Makefile.in
@@ -0,0 +1,8 @@
+MODULE    = xinputuap.dll
+IMPORTS   = hid setupapi advapi32 user32
+PARENTSRC = ../xinput1_3
+
+C_SRCS = \
+	main.c
+
+RC_SRCS = version.rc
diff --git a/dlls/xinputuap/version.rc b/dlls/xinputuap/version.rc
new file mode 100644
index 00000000000..f16ae7b6880
--- /dev/null
+++ b/dlls/xinputuap/version.rc
@@ -0,0 +1,27 @@
+/*
+ * The Wine project - Xinput Joystick Library
+ * Copyright 2021 Yusuf Khan
+ *
+ * This library is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU Lesser General Public
+ * License as published by the Free Software Foundation; either
+ * version 2.1 of the License, or (at your option) any later version.
+ *
+ * This library is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * Lesser General Public License for more details.
+ *
+ * You should have received a copy of the GNU Lesser General Public
+ * License along with this library; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA
+ */
+
+#define WINE_FILEDESCRIPTION_STR "Wine Common Controller API"
+#define WINE_FILENAME_STR "xinputuap.dll"
+#define WINE_FILEVERSION 10,0,14393,0000
+#define WINE_FILEVERSION_STR "10.0.14393.0000"
+#define WINE_PRODUCTVERSION 10,0,14393,0000
+#define WINE_PRODUCTVERSION_STR "10.0"
+
+#include "wine/wine_common_ver.rc"
diff --git a/dlls/xinputuap/xinputuap.spec b/dlls/xinputuap/xinputuap.spec
new file mode 100644
index 00000000000..1f2ae5bc251
--- /dev/null
+++ b/dlls/xinputuap/xinputuap.spec
@@ -0,0 +1 @@
+@ stdcall XInputGetState(long ptr)
-- 
2.30.2